Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## things.common.tools
Class Base64

    java.lang.Object
      things.common.tools.Base64

    public class Base64

extends java.lang.Object

This is a public domain source.

Encodes and decodes to and from Base64 notation.

Homepage: http://iharder.net/base64.

The `options` parameter, which appears in a few places, is used to pass several pieces of information to the encoder. In the "higher level" methods such as encodeBytes( bytes, options ) the options parameter can be used to indicate such things as first gzipping the bytes before encoding them, not inserting linefeeds (though that breaks strict Base64 compatibility), and encoding using the URL-safe and Ordered dialects.

The constants defined in Base64 can be OR-ed together to combine options, so you might make a call like this:

`String encoded = Base64.encodeBytes( mybytes, Base64.GZIP | Base64.DONT_BREAK_LINES );`

to compress the data before encoding it and then making the output have no newline characters.

Change Log:

- v2.2.2 - Fixed encodeFileToFile and decodeFileToFile to use the Base64.InputStream class to encode and decode on the fly which uses less memory than encoding/decoding an entire file into memory before writing.
- v2.2.1 - Fixed bug using URL_SAFE and ORDERED encodings. Fixed bug when using very small files (~< 40 bytes).
- v2.2 - Added some helper methods for encoding/decoding directly from one file to the next. Also added a main() method to support command line encoding/decoding from one file to the next. Also added these Base64 dialects:
  1. The default is RFC3548 format.
  2. Calling Base64.setFormat(Base64.BASE64_FORMAT.URLSAFE_FORMAT) generates URL and file name friendly format as described in Section 4 of RFC3548. http://www.faqs.org/rfcs/rfc3548.html
  3. Calling Base64.setFormat(Base64.BASE64_FORMAT.ORDERED_FORMAT) generates URL and file name friendly format that preserves lexical ordering as described in http://www.faqs.org/qa/rfcc-1940.html
  Special thanks to Jim Kellerman at http://www.powerset.com/ for contributing the new Base64 dialects.
- v2.1 - Cleaned up javadoc comments and unused variables and methods. Added some convenience methods for reading and writing to and from files.
- v2.0.2 - Now specifies UTF-8 encoding in places where the code fails on systems with other encodings (like EBCDIC).
- v2.0.1 - Fixed an error when decoding a single byte, that is, when the encoded data was a single byte.
- v2.0 - I got rid of methods that used booleans to set options. Now everything is more consolidated and cleaner. The code now detects when data that's being decoded is gzip-compressed and will decompress it automatically. Generally things are cleaner. You'll probably have to change some method calls that you were making to support the new options format (`int`s that you "OR" together).
- v1.5.1 - Fixed bug when decompressing and decoding to a byte[] using `decode( String s, boolean gzipCompressed )`. Added the ability to "suspend" encoding in the Output Stream so you can turn on and off the encoding if you need to embed base64 data in an otherwise "normal" stream (like an XML file).
- v1.5 - Output stream pases on flush() command but doesn't do anything itself. This helps when using GZIP streams. Added the ability to GZip-compress objects before encoding them.
- v1.4 - Added helper methods to read/write files.
- v1.3.6 - Fixed OutputStream.flush() so that 'position' is reset.
- v1.3.5 - Added flag to turn on and off line breaks. Fixed bug in input stream where last buffer being read, if not completely full, was not returned.
- v1.3.4 - Fixed when "improperly padded stream" error was thrown at the wrong time.
- v1.3.3 - Fixed I/O streams which were totally messed up.

I am placing this code in the Public Domain. Do with it as you will. This software comes with no guarantees or warranties but with plenty of well-wishing instead! Please visit http://iharder.net/base64 periodically to check for updates or to contribute improvements.

Version:
  2.2.2
Author:
  Robert Harder, rob@iharder.net

Nested Class Summary
`static class` | `Base64.InputStream` A `Base64.InputStream` will read data from another `java.io.InputStream`, given in the constructor, and encode/decode to/from Base64 notation on the fly.
`static class` | `Base64.OutputStream` A `Base64.OutputStream` will write data to another `java.io.OutputStream`, given in the constructor, and encode/decode to/from Base64 notation on the fly.

Field Summary
`static int` | `DECODE` Specify decoding.
`static int` | `DONT_BREAK_LINES` Don't break lines when encoding (violates strict Base64 specification)
`static int` | `ENCODE` Specify encoding.
`static int` | `GZIP` Specify that data should be gzip-compressed.
`static int` | `NO_OPTIONS` No options specified.
`static int` | `ORDERED` Encode using the special "ordered" dialect of Base64 described here: http://www.faqs.org/qa/rfcc-1940.html.
`static int` | `URL_SAFE` Encode using Base64-like encoding that is URL- and Filename-safe as described in Section 4 of RFC3548: http://www.faqs.org/rfcs/rfc3548.html.

Method Summary
`static byte[]` | `decode(byte[] source, int off, int len, int options)` Very low-level access to decoding ASCII characters in the form of a byte array.
`static byte[]` | `decode(java.lang.String s)` Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
`static byte[]` | `decode(java.lang.String s, int options)` Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
`static boolean` | `decodeFileToFile(java.lang.String infile, java.lang.String outfile)` Reads `infile` and decodes it to `outfile`.
`static byte[]` | `decodeFromFile(java.lang.String filename)` Convenience method for reading a base64-encoded file and decoding it.
`static boolean` | `decodeToFile(java.lang.String dataToDecode, java.lang.String filename)` Convenience method for decoding data to a file.
`static java.lang.Object` | `decodeToObject(java.lang.String encodedObject)` Attempts to decode Base64 data and deserialize a Java Object within.
`static java.lang.String` | `encodeBytes(byte[] source)` Encodes a byte array into Base64 notation.
`static java.lang.String` | `encodeBytes(byte[] source, int options)` Encodes a byte array into Base64 notation.
`static java.lang.String` | `encodeBytes(byte[] source, int off, int len)` Encodes a byte array into Base64 notation.
`static java.lang.String` | `encodeBytes(byte[] source, int off, int len, int options)` Encodes a byte array into Base64 notation.
`static boolean` | `encodeFileToFile(java.lang.String infile, java.lang.String outfile)` Reads `infile` and encodes it to `outfile`.
`static java.lang.String` | `encodeFromFile(java.lang.String filename)` Convenience method for reading a binary file and base64-encoding it.
`static java.lang.String` | `encodeObject(java.io.Serializable serializableObject)` Serializes an object and returns the Base64-encoded version of that serialized object.
`static java.lang.String` | `encodeObject(java.io.Serializable serializableObject, int options)` Serializes an object and returns the Base64-encoded version of that serialized object.
`static boolean` | `encodeToFile(byte[] dataToEncode, java.lang.String filename)` Convenience method for encoding data to a file.
`static void` | `main(java.lang.String[] args)` Encodes or decodes two files from the command line; feel free to delete this method (in fact you probably should) if you're embedding this code into a larger program.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### NO_OPTIONS

    public static final int NO_OPTIONS

  No options specified. Value is zero.

  See Also:
    Constant Field Values

### ENCODE

    public static final int ENCODE

  Specify encoding.

  See Also:
    Constant Field Values

### DECODE

    public static final int DECODE

  Specify decoding.

  See Also:
    Constant Field Values

### GZIP

    public static final int GZIP

  Specify that data should be gzip-compressed.

  See Also:
    Constant Field Values

### DONT_BREAK_LINES

    public static final int DONT_BREAK_LINES

  Don't break lines when encoding (violates strict Base64 specification)

  See Also:
    Constant Field Values

### URL_SAFE

    public static final int URL_SAFE

  Encode using Base64-like encoding that is URL- and Filename-safe as described in Section 4 of RFC3548: http://www.faqs.org/rfcs/rfc3548.html. It is important to note that data encoded this way is not officially valid Base64, or at the very least should not be called Base64 without also specifying that is was encoded using the URL- and Filename-safe dialect.

  See Also:
    Constant Field Values

### ORDERED

    public static final int ORDERED

  Encode using the special "ordered" dialect of Base64 described here: http://www.faqs.org/qa/rfcc-1940.html.

  See Also:
    Constant Field Values

Method Detail

### main

    public static final void main(java.lang.String[] args)

  Encodes or decodes two files from the command line; feel free to delete this method (in fact you probably should) if you're embedding this code into a larger program.

### encodeObject

    public static java.lang.String encodeObject(java.io.Serializable serializableObject)

  Serializes an object and returns the Base64-encoded version of that serialized object. If the object cannot be serialized or there is another error, the method will return `null`. The object is not GZip-compressed before being encoded.

  Parameters:
    `serializableObject` - The object to encode
  Returns:
    The Base64-encoded object
  Since:
    1.4

### encodeObject

    public static java.lang.String encodeObject(java.io.Serializable serializableObject,
                                                int options)

  Serializes an object and returns the Base64-encoded version of that serialized object. If the object cannot be serialized or there is another error, the method will return `null`.

  Valid options:

         GZIP: gzip-compresses object before encoding it.
         DONT_BREAK_LINES: don't break lines at 76 characters
           Note: Technically, this makes your encoding non-compliant.

  Example: `encodeObject( myObj, Base64.GZIP )` or

  Example: `encodeObject( myObj, Base64.GZIP | Base64.DONT_BREAK_LINES )`

  Parameters:
    `serializableObject` - The object to encode
    `options` - Specified options
  Returns:
    The Base64-encoded object
  Since:
    2.0
  See Also:
    `GZIP`, `DONT_BREAK_LINES`

### encodeBytes

    public static java.lang.String encodeBytes(byte[] source)

  Encodes a byte array into Base64 notation. Does not GZip-compress data.

  Parameters:
    `source` - The data to convert
  Since:
    1.4

### encodeBytes

    public static java.lang.String encodeBytes(byte[] source,
                                               int options)

  Encodes a byte array into Base64 notation.

  Valid options:

         GZIP: gzip-compresses object before encoding it.
         DONT_BREAK_LINES: don't break lines at 76 characters
           Note: Technically, this makes your encoding non-compliant.

  Example: `encodeBytes( myData, Base64.GZIP )` or

  Example: `encodeBytes( myData, Base64.GZIP | Base64.DONT_BREAK_LINES )`

  Parameters:
    `source` - The data to convert
    `options` - Specified options
  Since:
    2.0
  See Also:
    `GZIP`, `DONT_BREAK_LINES`

### encodeBytes

    public static java.lang.String encodeBytes(byte[] source,
                                               int off,
                                               int len)

  Encodes a byte array into Base64 notation. Does not GZip-compress data.

  Parameters:
    `source` - The data to convert
    `off` - Offset in array where conversion should begin
    `len` - Length of data to convert
  Since:
    1.4

### encodeBytes

    public static java.lang.String encodeBytes(byte[] source,
                                               int off,
                                               int len,
                                               int options)

  Encodes a byte array into Base64 notation.

  Valid options:

         GZIP: gzip-compresses object before encoding it.
         DONT_BREAK_LINES: don't break lines at 76 characters
           Note: Technically, this makes your encoding non-compliant.

  Example: `encodeBytes( myData, Base64.GZIP )` or

  Example: `encodeBytes( myData, Base64.GZIP | Base64.DONT_BREAK_LINES )`

  Parameters:
    `source` - The data to convert
    `off` - Offset in array where conversion should begin
    `len` - Length of data to convert
    `options` - Specified options
  Since:
    2.0
  See Also:
    `GZIP`, `DONT_BREAK_LINES`

### decode

    public static byte[] decode(byte[] source,
                                int off,
                                int len,
                                int options)

  Very low-level access to decoding ASCII characters in the form of a byte array. Does not support automatically gunzipping or any other "fancy" features.

  Parameters:
    `source` - The Base64 encoded data
    `off` - The offset of where to begin decoding
    `len` - The length of characters to decode
  Returns:
    decoded data
  Since:
    1.3

### decode

    public static byte[] decode(java.lang.String s)

  Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.

  Parameters:
    `s` - the string to decode
  Returns:
    the decoded data
  Since:
    1.4

### decode

    public static byte[] decode(java.lang.String s,
                                int options)

  Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.

  Parameters:
    `s` - the string to decode
    `options` - encode options such as URL_SAFE
  Returns:
    the decoded data
  Since:
    1.4

### decodeToObject

    public static java.lang.Object decodeToObject(java.lang.String encodedObject)

  Attempts to decode Base64 data and deserialize a Java Object within. Returns `null` if there was an error.

  Parameters:
    `encodedObject` - The Base64 data to decode
  Returns:
    The decoded and deserialized object
  Since:
    1.5

### encodeToFile

    public static boolean encodeToFile(byte[] dataToEncode,
                                       java.lang.String filename)

  Convenience method for encoding data to a file.

  Parameters:
    `dataToEncode` - byte array of data to encode in base64 form
    `filename` - Filename for saving encoded data
  Returns:
    `true` if successful, `false` otherwise
  Since:
    2.1

### decodeToFile

    public static boolean decodeToFile(java.lang.String dataToDecode,
                                       java.lang.String filename)

  Convenience method for decoding data to a file.

  Parameters:
    `dataToDecode` - Base64-encoded data as a string
    `filename` - Filename for saving decoded data
  Returns:
    `true` if successful, `false` otherwise
  Since:
    2.1

### decodeFromFile

    public static byte[] decodeFromFile(java.lang.String filename)

  Convenience method for reading a base64-encoded file and decoding it.

  Parameters:
    `filename` - Filename for reading encoded data
  Returns:
    decoded byte array or null if unsuccessful
  Since:
    2.1

### encodeFromFile

    public static java.lang.String encodeFromFile(java.lang.String filename)

  Convenience method for reading a binary file and base64-encoding it.

  Parameters:
    `filename` - Filename for reading binary data
  Returns:
    base64-encoded string or null if unsuccessful
  Since:
    2.1

### encodeFileToFile

    public static boolean encodeFileToFile(java.lang.String infile,
                                           java.lang.String outfile)

  Reads `infile` and encodes it to `outfile`.

  Parameters:
    `infile` - Input file
    `outfile` - Output file
  Returns:
    true if the operation is successful
  Since:
    2.2

### decodeFileToFile

    public static boolean decodeFileToFile(java.lang.String infile,
                                           java.lang.String outfile)

  Reads `infile` and decodes it to `outfile`.

  Parameters:
    `infile` - Input file
    `outfile` - Output file
  Returns:
    true if the operation is successful
  Since:
    2.2

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Things.